// ======================================================================
//
// mat_wu.cpp
// jeff grills
//
// copyright 1996 origin sytems inc
//
// ======================================================================

#include "first.h"
#include "mat_wu.h"
#include "gl_wu.h"
#include "palette.h"
#include "pal_wu.h"
#include "clut.h"
#include "raster.h"

// ======================================================================

MaterialData_wu::MaterialData_wu(int argR, int argG, int argB, int)
{
	RGB rgb;

	init();

	rgb.r = argR;
	rgb.g = argG;
	rgb.b = argB;

	// build the surface description
	surf             = NEW raster::solid_surface_desc;
	surf->shade_bits = GL_wu::getShadeBits();
	GL_wu::makeClut(&rgb, 1, &clut, &surf->clut);
}

// ----------------------------------------------------------------------

MaterialData_wu::MaterialData_wu(const Pixel8 *bitmap, int width, int height, const Palette *palette, bool transparency, const Pixel8 *)
{
	init();

	// build the texture info
	tmap                   = NEW raster::texture;
	tmap->map              = bitmap;
	tmap->has_transparency = transparency;
	tmap->shade_bits       = GL_wu::getShadeBits();
	tmap->clut             = static_cast<PaletteMaterialData_wu *>(palette->getMaterialData())->getClut();
	tmap->l2_dim[0]        = intLog2(width);
	tmap->l2_dim[1]        = intLog2(height);
}

// ----------------------------------------------------------------------

MaterialData_wu::MaterialData_wu(int, int, int, int, int, const Pixel8 *)
{
	init();

	ignore = true;
}

// ----------------------------------------------------------------------

MaterialData_wu::~MaterialData_wu(void)
{
	delete tmap;
	tmap = NULL;

	delete [] clut;
	clut = NULL;

	delete surf;
	surf = NULL;
}

// ----------------------------------------------------------------------

void MaterialData_wu::init(void)
{
	tmap    = NULL;
	surf    = NULL;
	clut    = NULL;

	ignore  = false;
}

// ======================================================================

